﻿#version 330 core

/*uniform mat4 World;
uniform mat4 View;
uniform mat4 Projection;*/
uniform mat4 PVWMatrix;
uniform mat4 NormalMatrix;
uniform mat4 DepthBias;

in vec3 in_position;
in vec2 in_texcoord;
in vec3 in_normal;

out vec3 pass_shadow_coord;
out vec2 pass_texcoord;
out vec3 pass_normal;

void main(void)
{
	gl_Position = PVWMatrix*vec4(in_position, 1);
	pass_texcoord = in_texcoord;
	pass_normal = (NormalMatrix * vec4(in_normal, 0)).xyz;
	pass_shadow_coord = (DepthBias * vec4(in_position, 1)).xyz;
}